using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Abstractas;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_Formularios.Controladoras;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;
using System.Linq;
using Exferia_Aplicacion.Modelos_MantenimientoAgrupacionesCabecera;
using Exferia_Aplicacion.Modelos_Listado_Filtros;

namespace Exferia_Formularios
{
    public partial class P_MantenimientoAgrupacionesCabecera : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_MantenimientoAgrupacionesCabecera_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;

        internal INTERNO_OpcionesDetalle_Modelo g_mdl_INTERNO_OpcionesDetalle_Modelo = null;
        internal ABS_MantenimientoAgrupacionesCabecera g_obj_ABS_MantenimientoAgrupacionesCabecera = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();

        private INTERNO_ConfiguracionPantalla_Modelo g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea = null;

        private bool g_bol_Modificando_SinRepeticiones = false;
        #endregion

        #region Objetos en Pantalla
        // Exferia_Label
        internal Exferia_Label Exferia_Label_Codigo { get { return ex_lbl_Codigo; } }
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_Descripcion; } }
        
        // Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Codigo { get { return ex_txt_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_Descripcion; } }

        // Exferia_CheckBox
        internal Exferia_CheckBox Exferia_CheckBox_Cliente { get { return ex_chk_Cliente; } }
        internal Exferia_CheckBox Exferia_CheckBox_Proveedor { get { return ex_chk_Proveedor; } }
        internal Exferia_CheckBox Exferia_CheckBox_SinRepeticiones { get { return ex_chk_SinRepeticiones; } }

        // Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_Lineas { get { return ex_dgv_Lineas; } }

        // Exferia_BarraProgreso
        internal Exferia_BarraProgreso Exferia_BarraProgreso_Lineas { get { return ex_pgb_BarraProgreso_Lineas; } }

        // Exferia_Button
        internal Exferia_Button Exferia_Button_Grabar { get { return ex_btn_Grabar; } }
        internal Exferia_Button Exferia_Button_Borrar { get { return ex_btn_Borrar; } }


        // Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_MantenimientoAgrupacionesCabecera { get { return ex_Paginador; } }
        #endregion

        #region Constructor
        public P_MantenimientoAgrupacionesCabecera(ABS_MantenimientoAgrupacionesCabecera _obj_ABS_MantenimientoAgrupacionesCabecera, INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo)
        {
            InitializeComponent();

            Repintar.Empezar(this);

            g_obj_Controladora = new P_MantenimientoAgrupacionesCabecera_Controladora(this);

            g_obj_ABS_MantenimientoAgrupacionesCabecera = _obj_ABS_MantenimientoAgrupacionesCabecera;

            //Buscar los Permisos
            g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_CABECERA());

            //Poner los Botones que no se Spueden poner bloqueados o de solo lectura .....................
            ex_btn_Borrar.Exferia_Button_Bloqueable = false;
            ex_btn_Grabar.Exferia_Button_Bloqueable = false;

            ex_btn_Lineas_Add.Exferia_Button_Bloqueable = false;
            ex_btn_Lineas_Ver.Exferia_Button_Bloqueable = false;
            ex_btn_Lineas_Filtros.Exferia_Button_Bloqueable = false;
            ex_btn_Lineas_Borrar.Exferia_Button_Bloqueable = false;
            ex_btn_Lineas_OrdenListado.Exferia_Button_Bloqueable = false;
            ex_cbo_Lineas_OrdenListado.Exferia_ComboBox_Bloqueable = false;
            //............................................................................................

            //Datos Opiones detalle
            g_mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_CABECERA());

            //Mirar si hay que bloquear los controles, si solo puede ver los datos
            if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
            {
                //Bloqueo los Controles
                SoloLectura.Empezar(this, true);
            }

            P_Base_TituloPantalla = g_mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento;

            if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
            {
                if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().NOMBRELISTADO_ALMACENARCONFIGURACION()))
                {
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea = Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().NOMBRELISTADO_ALMACENARCONFIGURACION()];
                }
            }

            try
            {
                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;
                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_MantenimientoAgrupacionesCabecera) + "/" + nameof(P_MantenimientoAgrupacionesCabecera));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                
                //Tipo de campo Codigo, poner como numeico o texto ...............................
                if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO != null)
                {
                    //Si no existe es Text
                    if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO.Where(m => m.nombreCampoCodigo.Equals(g_obj_ABS_MantenimientoAgrupacionesCabecera.NOMBRE_CAMPO_CODIGO_CABECERA()) && m.opcion.Equals(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_CABECERA())).FirstOrDefault() != null)
                    {
                        ex_txt_Codigo.Exferia_TextBox_Tipos = G_ENUM_TEXTBOX_TIPODATO.Digitos;
                        ex_txt_Codigo.Exferia_TextBox_Tipo_Decimal_Enteros = ex_txt_Codigo.Exferia_TextBox_MaxLength;

                        g_obj_Controladora.g_bol_CampoCodigo_Numerico = true;
                    }
                }
                //.........................................................................


                //Si es Agrupacion de Articulo, muestro la panel de check de cliente proveedor ----------------------------------------------------
                if (g_obj_ABS_MantenimientoAgrupacionesCabecera.ES_DEARTICULO_CABECERA())
                {
                    pnl_Auxiliar_ClienteProveedor.Visible = true;
                }
                else
                {
                    pnl_Auxiliar_ClienteProveedor.Visible = false;
                }
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_MantenimientoAgrupacionesCabecera) + "/" + nameof(P_MantenimientoAgrupacionesCabecera));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }

        }
        #endregion

        #region Inicio de pantalla
        private void P_MantenimientoAgrupacionesCabecera_Load(object sender, EventArgs e)
        {
            try
            {
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };


                //LINEAS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

                //Crear Columnas Listado
                CrearColumnas_Listado_Lineas();

                //Poner el tipo de orden si lo hubiera por defecto ######################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_ORDEN_DIRECCION_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Trim().Length > 0)
                {
                    //Descendente
                    if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Equals("1"))
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_Lineas_OrdenListado);
                        ex_btn_Lineas_OrdenListado.Tag = "1";

                    }
                    //Ascendente
                    else
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_Lineas_OrdenListado);
                        ex_btn_Lineas_OrdenListado.Tag = "0";
                    }
                }
                else
                {
                    if (g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().ORDENACION_TIPO_PORDEFECTO().Trim().Length > 0)
                    {
                        //Descendente
                        if (g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().ORDENACION_TIPO_PORDEFECTO().Equals("1"))
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_Lineas_OrdenListado);
                            ex_btn_Lineas_OrdenListado.Tag = "1";
                        }
                        //Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_Lineas_OrdenListado);
                            ex_btn_Lineas_OrdenListado.Tag = "0";

                        }
                    }
                }

                //Seleccionar Orden por Defecto en Combo #################################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_ORDEN_COLUMNA_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_ORDEN_COLUMNA_PORDEFECTO.Trim().Length > 0)
                {
                    ex_cbo_Lineas_OrdenListado.SelectedItem = ex_cbo_Lineas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Descripcion.Equals(g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_ORDEN_COLUMNA_PORDEFECTO)).FirstOrDefault();
                }
                else
                {
                    if (g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().ORDENACION_NOMBRECOLUMNA_PORDEFECTO().Trim().Length > 0)
                    {
                        ex_cbo_Lineas_OrdenListado.SelectedItem = ex_cbo_Lineas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().ORDENACION_NOMBRECOLUMNA_PORDEFECTO())).FirstOrDefault();
                    }
                    else
                    {
                        ex_cbo_Lineas_OrdenListado.SelectedItem = ex_cbo_Lineas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().FirstOrDefault();
                    }

                }
                //########################################################################################
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_MantenimientoAgrupacionesCabecera) + "/" + nameof(P_MantenimientoAgrupacionesCabecera_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_MantenimientoAgrupacionesCabecera_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                ex_txt_Codigo.Text = P_Base_Campo_1;
                                ex_txt_Descripcion.Exferia_TextBox_Foco();
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                ex_txt_Descripcion.Text = P_Base_Campo_2;
                                ex_txt_Codigo.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            ex_txt_Codigo.Exferia_TextBox_Foco();
                        }
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        ActivarBotones(false);
                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {

                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_MantenimientoAgrupacionesCabecera.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_MantenimientoAgrupacionesCabecera.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_MantenimientoAgrupacionesCabecera) + "/" + nameof(P_MantenimientoAgrupacionesCabecera_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        private void P_MantenimientoAgrupacionesCabecera_Enter(object sender, EventArgs e)
        {
            this.Activate();
        }

        private void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_MantenimientoAgrupacionesCabecera.Visible)
            {
                Exferia_Paginador_MantenimientoAgrupacionesCabecera.Visible = _bol_Activar;
            }

            if (ex_btn_Borrar.Enabled)
            {
                ex_btn_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones
        private void ex_btn_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos();
            }
        }

        private void ex_btn_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_INTERNO_OpcionesDetalle_Modelo.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }

        private void ex_btn_BuscarCodigoSiguiente_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Lineas

        private void CrearColumnas_Listado_Lineas()
        {
            ex_dgv_Lineas.AutoGenerateColumns = false;

            g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Lineas_Columnas = g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().LISTADO_COLUMNAS().Values.ToList();

            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Lineas_Columnas)
            {
                DataGridViewTextBoxColumn dgv_Columna = new DataGridViewTextBoxColumn();
                dgv_Columna.DataPropertyName = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.Name = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.HeaderText = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar;

                //Poner visible o no .........................................................................
                bool bol_Visible = true;
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto)
                {
                    bol_Visible = false;
                }
                else if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNASAMOSTRAR != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNASAMOSTRAR.Count > 0)
                {
                    if (!g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNASAMOSTRAR.Contains(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                    {
                        bol_Visible = false;
                    }
                }
                else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Mostrado_PorDefecto == false)
                {
                    bol_Visible = false;
                }
                dgv_Columna.Visible = bol_Visible;

                if (bol_Visible)
                {
                    g_obj_Controladora.g_lst_ColumnasAMostrar_Lineas.Add(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna);
                }
                //.....................................................................................................

                //Tipo de Formateo si fuera Fecha
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                {
                    dgv_Columna.DefaultCellStyle.Format = "d";
                }

                //Poner Ancho Columna ................................................................................
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNAS_ANCHO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNAS_ANCHO.Count > 0 &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNAS_ANCHO.ContainsKey(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                {
                    dgv_Columna.Width = g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNAS_ANCHO[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna];
                }
                else
                {
                    if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho > 0)
                    {
                        dgv_Columna.Width = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho;
                    }
                }
                //................................................................................................................

                dgv_Columna.ReadOnly = true;

                //Poner alineado segun tipo de datos ......................................................................................
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT))
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
                }
                else
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                }
                //..............................................................................................................................

                ex_dgv_Lineas.Columns.Add(dgv_Columna);

                //RELLENAR EL ORDEN EN COMBO
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto == false)
                {
                    ex_cbo_Lineas_OrdenListado.Items.Add(new INTERNO_ComboBox_Modelo(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna, mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar, null));
                }

            }

            //Cambiar el orden de las columnas ........
            if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNAS_ORDEN != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNAS_ORDEN.Count > 0)
            {
                foreach (KeyValuePair<string, int> kvp_Valores in g_mdl_INTERNO_ConfiguracionPantalla_Modelo_Linea.LISTADO_COLUMNAS_ORDEN)
                {
                    ex_dgv_Lineas.Columns[kvp_Valores.Key].DisplayIndex = kvp_Valores.Value;
                }
            }
            //.........................................
        }

        #region Botones
        private void ex_btn_Lineas_Add_Click(object sender, EventArgs e)
        {
            Add_Linea();
        }
        private void Add_Linea()
        {
            if ((Datos_Generales.Permisos_Comprobar(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA(), g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)))
            {
                //Por si se modifico algo en la cabecera que se grabe
                if (g_obj_Controladora.ComprobarCambios_SinPreguntar())
                {
                    INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA());

                    Rellenar_Listado_ParaPaginado();

                    //Buscar Opciones Modelo
                    P_MantenimientoAgrupacionesLineas frm_P_MantenimientoAgrupacionesLineas = new P_MantenimientoAgrupacionesLineas(P_Base_ValoresGenerales,
                                                                                    P_Base_FechaTrabajo,
                                                                                    mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                    g_obj_Controladora.g_mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo,
                                                                                    g_obj_ABS_MantenimientoAgrupacionesCabecera);

                    //Se llamo desde una pantalla
                    frm_P_MantenimientoAgrupacionesLineas.P_Base_TipoAperturaPantalla = 0;
                    frm_P_MantenimientoAgrupacionesLineas.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                    frm_P_MantenimientoAgrupacionesLineas.P_Base_PantallaOrigen = this;
                    frm_P_MantenimientoAgrupacionesLineas.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                    Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_MantenimientoAgrupacionesLineas, g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA());
                }
            }
        }

        private void ex_btn_Lineas_Ver_Click(object sender, EventArgs e)
        {
            Ver_Linea();
        }
        private void ex_dgv_Lineas_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_Linea();
        }
        private void Ver_Linea()
        {
            if ((Datos_Generales.Permisos_Comprobar(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA(), g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true)))
            {
                //Ver si hay alguno seleccionado
                if (ex_dgv_Lineas.Rows.Count > 0 && ex_dgv_Lineas.SelectedRows.Count > 0)
                {
                    //Por si se modifico algo en la cabecera que se grabe
                    if (g_obj_Controladora.ComprobarCambios_SinPreguntar())
                    {
                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA());

                        Rellenar_Listado_ParaPaginado();

                        //Buscar Opciones Modelo
                        P_MantenimientoAgrupacionesLineas frm_P_MantenimientoAgrupacionesLineas = new P_MantenimientoAgrupacionesLineas(P_Base_ValoresGenerales,
                                                                                                                                        P_Base_FechaTrabajo,
                                                                                                                                        mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                                                                        g_obj_Controladora.g_mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo,
                                                                                                                                        g_obj_ABS_MantenimientoAgrupacionesCabecera);

                        frm_P_MantenimientoAgrupacionesLineas.P_Base_TipoAperturaPantalla = 1;
                        frm_P_MantenimientoAgrupacionesLineas.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                        frm_P_MantenimientoAgrupacionesLineas.P_Base_PantallaOrigen = this;
                        frm_P_MantenimientoAgrupacionesLineas.P_Base_id = long.Parse(ex_dgv_Lineas.SelectedRows[0].Cells[nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id)].Value.ToString());
                        frm_P_MantenimientoAgrupacionesLineas.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                        Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_MantenimientoAgrupacionesLineas, g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA());
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }

        private void ex_btn_Lineas_Borrar_Click(object sender, EventArgs e)
        {
            Borrar_Linea();
        }
        private void Borrar_Linea()
        {
            if (Datos_Generales.Permisos_Comprobar(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA(), g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                //Ver si hay algunbo seleccionado
                if (ex_dgv_Lineas.Rows.Count > 0 && ex_dgv_Lineas.SelectedRows.Count > 0)
                {
                    List<long> lst_ids_ABorrar = new List<long>();
                    foreach (DataGridViewRow dgvr in ex_dgv_Lineas.SelectedRows)
                    {
                        lst_ids_ABorrar.Add(long.Parse(dgvr.Cells[nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id)].Value.ToString()));
                    }

                    g_obj_Controladora.BorrarDatos_Linea(lst_ids_ABorrar);
                        
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }
        #endregion

        #region Ordenar
        private void ex_btn_Lineas_OrdenListado_Click(object sender, EventArgs e)
        {
            //Esta Descedente
            if (ex_btn_Lineas_OrdenListado.Tag.ToString().Equals("1"))
            {
                Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_Lineas_OrdenListado);
            }
            //Esta Ascendente
            else
            {
                Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_Lineas_OrdenListado);
            }

            Linea_Ordenar_DataGridView();
        }
        private void ex_dgv_Lineas_ColumnHeaderMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            try
            {
                //Mostrar u Ocultar las columnas
                if (e.Button == MouseButtons.Left)
                {
                    string str_CambioOrdenAnterior = "";
                    if (ex_cbo_Lineas_OrdenListado.SelectedItem != null)
                    {
                        str_CambioOrdenAnterior = ((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Identificador;
                    }

                    //Seleccionar la columna en el Combo de orden
                    ex_cbo_Lineas_OrdenListado.SelectedItem = ex_cbo_Lineas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(ex_dgv_Lineas.Columns[e.ColumnIndex].Name)).FirstOrDefault();

                    if (str_CambioOrdenAnterior.Equals(((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Identificador))
                    {
                        //Si estaba Ascendente lo pongo descendente
                        if (ex_dgv_Lineas.SortOrder == SortOrder.Ascending)
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_Lineas_OrdenListado);
                        }
                        //Si estaba descendente lo pongo Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_Lineas_OrdenListado);
                        }
                    }

                    Linea_Ordenar_DataGridView();
                }
            }
            catch
            { }
        }
        private void ex_cbo_Lineas_OrdenListado_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Saber el Tipo de Ordenacion .................................
            ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
            if (ex_btn_Lineas_OrdenListado.Tag.ToString().Equals("1"))
            {
                obj_ListSortDirection = ListSortDirection.Descending;
            }
            //..............................................................

            //Cambiar el tipo Orden en Listado
            ex_dgv_Lineas.Sort(ex_dgv_Lineas.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);

            Linea_Ordenar_DataGridView();
        }

        public void Linea_Ordenar_DataGridView()
        {
            try
            {
                if (ex_dgv_Lineas.Rows.Count > 0)
                {
                    //Saber el Tipo de Ordenacion .................................
                    ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
                    if (ex_btn_Lineas_OrdenListado.Tag.ToString().Equals("1"))
                    {
                        obj_ListSortDirection = ListSortDirection.Descending;
                    }
                    //..............................................................

                    if (ex_cbo_Lineas_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                    {
                        ex_dgv_Lineas.Sort(ex_dgv_Lineas.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);
                    }
                    else
                    {
                        ex_dgv_Lineas.Sort(ex_dgv_Lineas.Columns[g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().ORDENACION_NOMBRECOLUMNA_PORDEFECTO()], obj_ListSortDirection);
                    }
                }
            }
            catch (Exception)
            { }
        }
        #endregion

        #region Filtros
        private void ex_btn_Lineas_Filtros_Click(object sender, EventArgs e)
        {
            MostrarOcultar_Columnas_Y_Fitros_Linea(ex_btn_Lineas_Filtros.Location.X, 0);
        }
        private void MostrarOcultar_Columnas_Y_Fitros_Linea(int _int_PosicionX, int _int_PosicionY)
        {
            PE_Listados_Filtros frm_PE_Listados_Filtros = new PE_Listados_Filtros(g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS(), ex_dgv_Lineas.Columns, g_obj_Controladora.g_dct_ListadoFiltros_Lineas);

            frm_PE_Listados_Filtros.ShowDialog();

            if (frm_PE_Listados_Filtros.g_bol_BotonAceptar)
            {
                //Mostrar/Ocultar las Columnas que no esten en el Listado
                g_obj_Controladora.g_lst_ColumnasAMostrar_Lineas = frm_PE_Listados_Filtros.g_lst_ColumnasAMostrar;

                foreach (DataGridViewColumn dgvc_ColumnasActuales in ex_dgv_Lineas.Columns)
                {
                    //Mostrar
                    if (g_obj_Controladora.g_lst_ColumnasAMostrar_Lineas.Contains(dgvc_ColumnasActuales.Name))
                    {
                        dgvc_ColumnasActuales.Visible = true;
                    }
                    //Ocultar
                    else
                    {
                        dgvc_ColumnasActuales.Visible = false;
                    }
                }

                //Rellenar los nuevos filtros
                g_obj_Controladora.g_dct_ListadoFiltros_Lineas = frm_PE_Listados_Filtros.g_dct_ListadoFiltros.ToDictionary(entry => entry.Key, entry => entry.Value);

                //Recargar el Listado
                g_obj_Controladora.Rellenar_DataGrid_Linea();
            }
        }
        #endregion


        #endregion

        public void Rellenar_Listado_ParaPaginado()
        {
            //Poner el Listado para el paginado ....................................................
            List<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo> lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = g_obj_Controladora.Filtrar_Linea();
            if (lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo != null && lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Count > 0)
            {
                string str_CampoOrdenar = g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().ORDENACION_NOMBRECOLUMNA_PORDEFECTO();
                if (ex_cbo_Lineas_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                {
                    str_CampoOrdenar = ((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Identificador;
                }

                //Descendente
                if (ex_btn_Lineas_OrdenListado.Tag.ToString().Equals("1"))
                {
                    lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.OrderByDescending(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                }
                //Ascendente
                else
                {
                    lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.OrderBy(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                }

                P_Base_Objetos_Filtrados = lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
            }
            else
            {
                P_Base_Objetos_Filtrados = null;
            }
            //......................................................................................
        }

        private void ex_chk_SinRepeticiones_CheckedChanged(object sender, EventArgs e)
        {
            if (g_bol_Modificando_SinRepeticiones == false)
            {
                if (ex_chk_SinRepeticiones.Checked)
                {
                    g_bol_Modificando_SinRepeticiones = true;

                    if (ex_dgv_Lineas.Rows!=null && ex_dgv_Lineas.Rows.Count>1)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_AGRUPACIONESCABECERA_TIENELINEAS);
                        ex_chk_SinRepeticiones.Checked = false;
                    }

                    g_bol_Modificando_SinRepeticiones = false;
                }

                Controlar_Modificaciones();
            }
        }

        public override void P_Base_ActualizarRegistro_ConObjeto(object _obj, G_ENUM_TIPOACCION _enum_TipoAccion)
        {
            try
            {
                if (_obj != null)
                {
                    if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_INSERTAR) ||
                        _enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_MODIFICAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //Linea
                        if (obj_Opcion.Equals(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA()))
                        {
                            g_obj_Controladora.Linea_Actualizar_Registro((long)lst_obj[1], _enum_TipoAccion, false);
                        }
                    }
                    else if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_ELIMINAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //Linea
                        if (obj_Opcion.Equals(g_obj_ABS_MantenimientoAgrupacionesCabecera.OPCION_LINEA()))
                        {
                            g_obj_Controladora.Linea_Borrar_Registro((List<long>)lst_obj[1]);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_MantenimientoAgrupacionesCabecera) + "/" + nameof(P_Base_ActualizarRegistro_ConObjeto));
            }
        }

        #region Control CheckBox
        private void ex_chk_Cliente_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void ex_chk_Proveedor_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }
        #endregion

        #region Eventos del paginador

        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_MantenimientoAgrupacionesCabecera.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_MantenimientoAgrupacionesCabecera.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_MantenimientoAgrupacionesCabecera.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_MantenimientoAgrupacionesCabecera.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_MantenimientoAgrupacionesCabecera.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_MantenimientoAgrupacionesCabecera.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    g_timer_Paginar.Stop();
                    g_obj_Controladora.RecargarDatos();
                }
            }
        }

        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base_EjecutandoEvento();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        public void Controlar_Modificaciones_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        public void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        public void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        #endregion

        private void P_MantenimientoAgrupacionesCabecera_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                //Listado de Agrupaciones incluir Registros ....................................................................
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo = new INTERNO_ConfiguracionPantalla_Modelo();

                Dictionary<string, int> dct_ColumnasOrden_INCLUIRREGISTROS = new Dictionary<string, int>();
                Dictionary<string, int> dct_ColumnasAncho_INCLUIRREGISTROS = new Dictionary<string, int>();
                foreach (DataGridViewColumn dgv_Columnas in ex_dgv_Lineas.Columns)
                {
                    //Campos a Mostrar
                    if (dgv_Columnas.Visible)
                    {
                        //Columnas Orden
                        dct_ColumnasOrden_INCLUIRREGISTROS.Add(dgv_Columnas.Name, dgv_Columnas.DisplayIndex);

                        //Columnas Ancho
                        dct_ColumnasAncho_INCLUIRREGISTROS.Add(dgv_Columnas.Name, dgv_Columnas.Width);
                    }
                }
                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNASAMOSTRAR = g_obj_Controladora.g_lst_ColumnasAMostrar_Lineas;
                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ORDEN = dct_ColumnasOrden_INCLUIRREGISTROS;
                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ANCHO = dct_ColumnasAncho_INCLUIRREGISTROS;

                //Orden
                if (ex_cbo_Lineas_OrdenListado.SelectedItem != null)
                {
                    mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_COLUMNA_PORDEFECTO = ((INTERNO_ComboBox_Modelo)ex_cbo_Lineas_OrdenListado.SelectedItem).Descripcion;
                }

                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_DIRECCION_PORDEFECTO = ex_btn_Lineas_OrdenListado.Tag.ToString();

                //Actualizar la Variables General
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().NOMBRELISTADO_ALMACENARCONFIGURACION()] = mdl_INTERNO_ConfiguracionPantalla_Modelo;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                }

                //Actualizar el fichero XML
                Funciones_FicherosXML.ModificarXML_ConfiguracionPantallas(Variables.G_STR_CONFIGURACIONPANTALLA_TIPOPANTALLA_LISTADOS, g_obj_ABS_MantenimientoAgrupacionesCabecera.LISTADO_LINEAS().NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                //..........................................................................................................................            
            }
            catch (Exception)
            { }


        }

        
    }
}
